package barrick;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * Created by IntelliJ IDEA. User: barrick Date: Apr 10, 2004 Time: 2:01:37 PM
 * To change this template use File | Settings | File Templates.
 */
public class JThreadControlPanel extends JPanel {
    private ThreadControlable m_controlable;
    private JButton m_stop;
    private JButton m_run;
    private JButton m_pause;
    private JButton m_step;

 
    public void setUpdateButtons(boolean m_update_buttons) {
        this.m_update_buttons = m_update_buttons;
    }

    private boolean m_update_buttons = true;

    public JThreadControlPanel(ThreadControlable tc)
    {
        super();
        m_controlable = tc;

        setLayout(new GridLayout(2,2));

        m_stop = new JButton("Stop");
        m_run = new JButton("Run");
        m_pause = new JButton("Pause");
        m_step = new JButton("Step");

        add(m_run);
        add(m_pause);
        add(m_stop);
        add(m_step);
        setMinimumSize(new Dimension(200,60));
        setMaximumSize(new Dimension(200,60));
        setPreferredSize(new Dimension(200,60));

        m_run.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event) {
                try {
                    m_controlable.run();
                } catch (ThreadControlException e) {
                    JOptionPane.showMessageDialog(JThreadControlPanel.this.getParent(),
                            "ThreadControlException: " + e.toString());
                }
                updateButtons();
            }
        }       );

        m_pause.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event) {
                try {
                    m_controlable.pause();
                } catch (ThreadControlException e) {
                    JOptionPane.showMessageDialog(JThreadControlPanel.this.getParent(),
                            "ThreadControlException: " + e.toString());
                }
                updateButtons();
            }
        }       );

        m_stop.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event) {
                try {
                    m_controlable.stop();
                } catch (ThreadControlException e) {
                    JOptionPane.showMessageDialog(JThreadControlPanel.this.getParent(),
                            "ThreadControlException: " + e.toString());
                }
                updateButtons();
            }
        }       );

         m_step.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event) {
                try {
                    m_controlable.step();
                } catch (ThreadControlException e) {
                    JOptionPane.showMessageDialog(JThreadControlPanel.this.getParent(),
                            "ThreadControlException: " + e.toString());
                }
                updateButtons();
            }
        }       );

    }

    public void updateButtons()
    {
        if(!m_update_buttons) return;
        if(m_controlable.isStopped())
        {
            m_run.setEnabled(false);
            m_pause.setEnabled(false);
            m_step.setEnabled(false);
            m_stop.setEnabled(true);
            return;
        }

        if(m_controlable.isPaused())
        {
            m_run.setEnabled(true);
            m_pause.setEnabled(false);
            m_step.setEnabled(true);
            m_stop.setEnabled(true);
            return;
        }
            m_run.setEnabled(false);
            m_pause.setEnabled(true);
            m_step.setEnabled(false);
            m_stop.setEnabled(true);

    }

}
