package barrick;

import java.util.LinkedList;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA. User: barrick Date: Apr 10, 2004 Time: 2:22:47 PM
 * To change this template use File | Settings | File Templates.
 */
public class ThreadControlGroup implements ThreadControlable {
    private LinkedList m_list;

    public ThreadControlGroup()
    {
        m_list = new LinkedList();
    }

    public void add(ThreadControlable tc)
    {
        m_list.addLast(tc);
    }

    public void run() throws ThreadControlException {
        if(m_list.size() <=0 ) return;
        Iterator i = m_list.iterator();
        while(i.hasNext())
        {
            ThreadControlable tc = (ThreadControlable)i.next();
            if(tc.isPaused() && !tc.isStopped())
                tc.run();
        }
    }

    public void step() throws ThreadControlException {
        if(m_list.size() <=0 ) return;
        Iterator i = m_list.iterator();
        while(i.hasNext())
        {
            ThreadControlable tc = (ThreadControlable)i.next();
            if(tc.isPaused() && !tc.isStopped())
                tc.step();
        }
    }

    public void pause() throws ThreadControlException {
         if(m_list.size() <=0 ) return;
        Iterator i = m_list.iterator();
        while(i.hasNext())
        {
            ThreadControlable tc = (ThreadControlable)i.next();

                tc.pause();
        }

    }

    public void stop() throws ThreadControlException {
        if(m_list.size() <=0 ) return;
        Iterator i = m_list.iterator();
        while(i.hasNext())
        {
            ThreadControlable tc = (ThreadControlable)i.next();
                tc.stop();
        }
    }

    public boolean isStopped() {
        if(m_list.size() <= 0) return true;
        else return ((ThreadControlable)(m_list.getFirst())).isStopped();
    }

    public boolean isPaused() {
        if(m_list.size() <= 0) return true;
         Iterator i = m_list.iterator();
        while(i.hasNext())
        {
            ThreadControlable tc = (ThreadControlable)i.next();
            if(!tc.isPaused()) return false;
        }
        return true;
        
    }
}
