package barrick;

import javax.swing.*;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.IOException;

/**
 * A simple class for testing ThreadControl framework. It writes information
 * to provided OutputStream when it runs
 */
public class ThreadWriter extends ControledThread {
    private JTextArea m_output;
    private StringBuffer m_display;
    private long m_delay;

    private long m_count = 0;


    /**
     * Create a new ThreadWriter that will write with the specified delay
     * after each write.
     * @param out  Stream to output to
     * @param delay  Length of delay in milliseconds
     */
    public ThreadWriter(JTextArea out, long delay)
    {
        m_delay = delay;
        m_output = out;
        m_display = new StringBuffer();

        for(int i=0; i < 10; i++)
        {
            m_display.append('0');
        }
        m_display.append('\n');
    }


    public  void doStep() {
        m_display.setCharAt((int)(m_count % 10),'0');
        ++m_count;
        m_display.setCharAt((int)(m_count % 10),'1');

        m_output.insert(Long.toString(m_count) + "\t" + m_display.toString(), 0);


        try {
            Thread.currentThread().sleep(m_delay);
        } catch (InterruptedException e) {
            //Ignore
        }
    }

    protected void doStop() {
        super.doStop();
        m_output.append("ThreadWriter stopped: " + m_count);
    }
}
